--[[ For prospecting the macro should be: /run ProspectButtonSetup() /click ProspectButton ]]

local L = LibStub("AceLocale-3.0"):GetLocale("ProspectButton")
local prospect = CreateFrame("CheckButton","ProspectButton",UIParent,"SecureActionButtonTemplate")
prospect:SetAttribute("type","macro")
local _, _, _, item_ore = GetAuctionItemSubClasses(6) --Simple way to get ingame localized ItemType "Metal and Stone" through Auctionshouseframe translation

local function findmetal()
	local function f(b,s)
		if GetContainerItemLink(b,s) then
			local itemName,itemLink,_,_,_,_,itemType = GetItemInfo(GetContainerItemID(b,s))
			local itemID = GetContainerItemID(b,s)
			local db = ProspectButton_Ore.NotProspectable
				--search internal db for ignored ore ids and skip them
			for h=1,#db do
				local ore = db[h]
				if itemID==ore then
					return
				end
			end
			return (itemType==item_ore) and select(2,GetContainerItemInfo(b,s))>=5
		end
	end
	for i=0,4 do
		for j=1,GetContainerNumSlots(i) do
			if f(i,j) then
				return i,j
			end
		end
	end
end

function ProspectButtonSetup()
local prospect_spell = GetSpellInfo(31252) --SpellID for prospecting
	local b,s = findmetal()
	if (not b or not s) or LootFrame:IsVisible() or CastingBarFrame:IsVisible() or UnitCastingInfo("player") then
	-- do nothing if no herb, if looting or casting
		ProspectButton:SetAttribute("macrotext","")
		if not b then
			DEFAULT_CHAT_FRAME:AddMessage("|cFF00FF00ProspectButton: |r"..L["error"])
		end
	else
		ProspectButton:SetAttribute("macrotext","/"..L["macro_cast"].." "..prospect_spell.."\n/"..L["macro_use"].." "..b.." "..s)
	end
end